require 'binformat'

class BMPFileHeader < Binformat
  byte :type, 2
  int :size
  short :reserved1
  short :reserved2
  int :offbytes
end

class BMPInfoHeader < Binformat
  int :size
  int :width
  int :height
  short :planes
  short :bitCount
  int :compression
  int :sizeImage
  int :xPixPerMeter
  int :yPixPerMeter
  int :clrUsed
  int :clrImportant
end

class BMPPalette < Binformat
  byte :r
  byte :g
  byte :b
  byte :unused
end

class BMP < Binformat
  struct BMPFileHeader, :fileHdr
  struct BMPInfoHeader, :infoHdr
  struct BMPPalette, :palette, proc { infoHdr[0].assoc(:clrUsed)[1] }
end

$BINFORMAT_PROVIDE = BMP

if $0 == __FILE__
  require 'yaml'

  f = BMP.new
  r = f.parse(ARGF)
  p r[2][1][5]
  r[2][1][5][0][1]=255
  r[2][1][5][1][1]=255
  r[2][1][5][2][1]=255
  r[2][1][5][3][1]=255
  File.open('out.bmp','w') do |of|
    of.print(f.dump(r))
    of.print(ARGF.read)
  end
#  puts r.to_yaml
end

