require 'binformat'

class Phdr < Binformat
  int :type;
  int :offset;
  addr :vaddr;
  addr :paddr;
  int :filesz;
  int :memsz;
  int :flags;
  int :align;
end

class Shdr < Binformat
  int :name
  int :type
  int :flags
  addr :addr
  int :offset
  int :size
  int :link
  int :info
  int :addralign
  int :entsize
end

class ELF < Binformat
  byte :magic, 4
  byte :ident_class
  byte :ident_data
  byte :ident_version
  byte :ident_osabi
  byte :ident_rest, 8
  short :type
  short :machine
  int :version
  addr :entry
  int :phoff
  int :shoff
  int :flags
  short :ehsize
  short :phentsize
  short :phnum
  short :shentsize
  short :shnum
  short :shstrndx

  seek :phoff

  struct Phdr, :phdr, :phnum

  seek :shoff

  struct Shdr, :shdr, :shnum

end

$BINFORMAT_PROVIDE = ELF

if $0 == __FILE__
  require 'yaml'

  cf = ELF.new
#  p cf.parse(ARGF)
  r = cf.parse(ARGF)
  puts r.to_yaml
  puts 'rest:'
  p ARGF.read

#   File.open('out', 'w') do |of|
#     of.print(cf.dump(r))
#   end
end

